package com.jisco.dynamicweight.pika.controller;

import com.jisco.dynamicweight.pika.model.Centernet;
import com.jisco.dynamicweight.pika.service.ICenternetService;
import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * Centernet RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2022-02-11 11:33
 * 类描述
 * 修订历史：
 * 日期：2022-02-11
 * 作者：generator
 * 参考：
 * 描述：Centernet RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/centernets")
public class CenternetController extends BaseRESTfulController {

    @Autowired
    ICenternetService centernetService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("centernet:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<Centernet> list = centernetService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("centernet:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<Centernet> list = centernetService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据Centernet对象创建")
    @ApiImplicitParam(name = "centernet", value = "详细实体centernet", required = true, dataType = "Centernet")
    //@RequiresPermissions("centernet:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@RequestBody Centernet model){
        Centernet centernet = centernetService.add(model);
        return success(centernet);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("centernet:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id){
        Centernet centernet = centernetService.getById(id);
        return success(centernet);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的centernet信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
        @ApiImplicitParam(name = "centernet", value = "详细实体centernet", required = true, dataType = "Centernet")
    })
    //@RequiresPermissions("centernet:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody Centernet model){
        model.setId(id);
        Centernet centernet = centernetService.modify(model);
        return success(centernet);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("centernet:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<String> ids = ListUtils.convertList(list);
			  centernetService.delete(ids);
    	}
      return success();
    }
}
